<template>
    <a-row :gutter="8" :wrap="false">
        <a-col flex="auto">
            <a-card type="flex">
                <x-action-bar class="mb-8-2">
                    <a-button type="primary" @click="$refs.editDialogRef.handleCreate()">
                        <template #icon>
                            <plus-outlined></plus-outlined>
                        </template>
                        新增门店
                    </a-button>
                </x-action-bar>
                <a-table :columns="columns" :data-source="listData" bordered="true" :loading="loading"
                    :pagination="paginationState" @change="onTableChange">
                    <template #bodyCell="{ column, record }">
                        <template v-if="'status' === column.dataIndex">
                            <a-tag :color="storeStatus.getColor(record.status)">{{ storeStatus.getName(record.status)
                                }}</a-tag>
                        </template>
                        <template v-if="'action' === column.key">
                            <x-action-button @click="$refs.editDialogRef.handleEdit(record)">
                                <a-tooltip>
                                    <template #title>编辑</template>
                                    <edit-outlined /> </a-tooltip></x-action-button>
                            <x-action-button @click="auditHandleEdit(record)" v-if="record.status === 1">
                                <a-tooltip>
                                    <template #title>审核</template>
                                    <i class='iconfont icon-shenhe' style='font-size:14px;color:#faad14'></i>
                                </a-tooltip>
                            </x-action-button>
                            <x-action-button @click="handleDelete(record.id)">
                                <a-tooltip>
                                    <template #title>删除</template>
                                    <delete-outlined style="color: #ff4d4f" />
                                </a-tooltip>
                            </x-action-button>
                        </template>
                    </template>
                </a-table>
            </a-card>
        </a-col>
    </a-row>
    <a-modal :open="open" :title="'审核'" :width="640" title="审核" ok-text="确认" cancel-text="取消" @ok="handleAuditEdit"
        @cancel="open = false">
        <a-card class="mb-8-2">
            <a-form-item :label="'审核'" name="">
                <a-radio-group v-model:value="auditStatus"
                    :options="[{ value: 2, label: '通过' }, { value: 99, label: '不通过' }]"></a-radio-group>
            </a-form-item>
            <a-form-item :label="'备注'" name="">
                <a-textarea v-model:value="remark"></a-textarea>
            </a-form-item>
        </a-card>
    </a-modal>
    <edit-dialog ref="editDialogRef" @ok="onOk"></edit-dialog>
</template>

<script setup>
import { message, Modal } from 'ant-design-vue'
import { ref } from 'vue'
import apis from '@/apis'
import { config } from '@/config'
import { usePagination } from '@/hooks'
import EditDialog from './components/EditDialog.vue'
import { PlusOutlined, EditOutlined, DeleteOutlined } from '@ant-design/icons-vue'
import { useI18n } from 'vue-i18n'
import { storeStatus } from '@/enums/index.js'
defineOptions({
    name: 'serverList',
})
const { t } = useI18n() // 解构出t方法
const columns = [
    { title: '所属分类', dataIndex: 'label' },
    { title: '门店名称', dataIndex: 'storeName', ellipsis: true },
    // { title: '门店封面', dataIndex: 'storeCover' },
    { title: '经度', dataIndex: 'longitude' },
    { title: '纬度', dataIndex: 'latitude' },
    { title: '详细地址', dataIndex: 'storeAddress', ellipsis: true },
    { title: '营业时间', dataIndex: 'openAt' },
    { title: '状态', dataIndex: 'status', width: 120, align: 'center' },
    { title: t('button.action'), key: 'action', fixed: 'right', width: 140, align: 'center' },
]
const { listData, loading, showLoading, hideLoading, paginationState, resetPagination, searchFormData } =
    usePagination()
const currentForm = ref({})
const open = ref(false)
const auditStatus = ref(2)
const remark = ref('')
const editDialogRef = ref()
getPageList()
/**
 * 获取用户列表
 * @returns {Promise<void>}
 */
async function getPageList() {
    try {
        showLoading()
        const { pageSize, current } = paginationState
        const { success, data, total } = await apis.serverList
            .getDataList({
                pageSize,
                current: current,
            })
            .catch(() => {
                throw new Error()
            })
        hideLoading()
        if (config('http.code.success') === success) {
            listData.value = data.map(item => ({
                ...item,
                key: item.value
            }))
            paginationState.total = total
        }
    } catch (error) {
        hideLoading()
    }
}
const auditHandleEdit = (params) => {
    currentForm.value = params
    open.value = true
}
const handleAuditEdit = async () => {
    try {
        const params = {
            ...currentForm.value,
            status: auditStatus.value,
            remark: remark.value
        }
        const result = await apis.serverList.updateMenu(currentForm.value.id, params).catch(() => {
            throw new Error()
        })
        if (config('http.code.success') === result?.success) {
            getPageList()
            open.value = false
            message.success('审核成功')
        }
    } catch (error) {
        message.error(error.message)
    }
}
/**
 * 删除
 */
function handleDelete(value) {
    Modal.confirm({
        title: '确定撤销该工单吗',
        content: t('button.confirm'),
        okText: t('button.confirm'),
        onOk: () => {
            return new Promise((resolve, reject) => {
                ; (async () => {
                    try {
                        const { success } = await apis.serverList.delMenu(value).catch(() => {
                            throw new Error()
                        })
                        if (config('http.code.success') === success) {
                            resolve()
                            message.success(t('component.message.success.delete'))
                            await getPageList()
                        }
                    } catch (error) {
                        reject()
                    }
                })()
            })
        },
    })
}

/**
 * 分页
 */
function onTableChange({ current, pageSize }) {
    paginationState.current = current
    paginationState.pageSize = pageSize
    getPageList()
}

/**
 * 搜索
 */
function handleSearch() {
    resetPagination()
    getPageList()
}
/**
 * 重置
 */
function handleResetSearch() {
    searchFormData.value = {}
    resetPagination()
    getPageList()
}
/**
 * 编辑完成
 */
async function onOk() {
    await getPageList()
}
</script>

<style lang="less" scoped></style>
